@echo off
if not exist obj mkdir obj

cd obj
if exist *.o del *.o
if exist *.ppu del *.ppu
if exist *.a del *.a
cd ..

echo Now assembling, compiling, and linking your kernel:
nasm -f elf -o obj\stub.o stub.asm
if errorlevel 1 goto error

set FPCOPT=-Aelf -n -XX -CX -O3 -OoREGVAR -OpPENTIUM3 -Sgic -Xd -Rintel -Tlinux -FUobj
set FILES=kernel.pas main.pas gdt.pas idt.pas isr.pas

for %%f in (%FILES%) do (
  fpc %FPCOPT% %%f
  if errorlevel 1 goto error
)

cd obj
del *.ppu
cd ..

i386-linux-ld -T linker.ld -o fpcos obj\*.o
if errorlevel 1 goto error

cat stage1 stage2 pad fpcos > fpcos.img
if errorlevel 1 goto error

echo Success!
goto end
:error
echo Failed!
:end
rem pause
