unit gdt;

interface

type

  TGDTEntry = packed record
    LowLimit: Word;
    LowBase: Word;
    MiddleBase: Byte;
    Access: Byte;
    Granularity: Byte;
    HighBase: Byte;
  end;

  TGDTPtr = packed record
    Limit: Word;
    Base: LongWord;
  end;

var
  GDTList: array [0..2] of TGDTEntry;
  GDTPtr: TGDTPtr; export name 'gdt_ptr';

procedure FlushGDT; external name 'flush_gdt';
procedure SetGDTGate(num: LongInt; base,limit: LongWord; acc,gran: Byte);
procedure InstallGDT;

implementation

procedure SetGDTGate(num: LongInt; base,limit: LongWord; acc,gran: Byte);
begin
  with GDTList[num] do begin
    LowBase:=(base and $FFFF);
    MiddleBase:=(base shr 16) and $FF;
    HighBase:=(base shr 24) and $FF;
    LowLimit:=(limit and $FFFF);
    Granularity:=((limit shr 16) and $0F);
    Granularity:=Granularity or (gran and $F0);
    Access:=acc;
  end;
end;

procedure InstallGDT;
begin
  with GDTPtr do begin
    Limit:=SizeOf(GDTList)-1;
    Base:=PtrUInt(@GDTList);
  end;
  SetGDTGate(0,0,0,0,0);
  SetGDTGate(1,0,$FFFFFFFF,$9A,$CF);
  SetGDTGate(2,0,$FFFFFFFF,$92,$CF);
  FlushGDT;
  end;
end.
