unit idt;

interface

type

  TIDTEntry = packed record
    LowBase: Word;
    Selector: Word;
    Always0: Byte;
    Flags: Byte;
    HiBase: Word;
  end;

  TIDTPtr = packed record
    Limit: Word;
    Base: LongWord;
  end;

var
  IDTList: array [0..255] of TIDTEntry;
  IDTPtr: TIDTPtr; export name 'idt_ptr';

procedure LoadIDT; external name 'load_idt';
procedure SetIDTGate(num: Byte; base: LongWord; sel: Word; flg: Byte);
procedure InstallIDT;

implementation

uses
  main;

procedure SetIDTGate(num: Byte; base: LongWord; sel: Word; flg: Byte);
begin
  with IDTList[num] do begin
    LowBase:=base and $FFFF;
    HiBase:=(base shr 16) and $FFFF;
    Selector:=sel;
    Always0:=0;
    Flags:=flg;
  end;
end;

procedure InstallIDT;
begin
  with IDTPtr do begin
    Limit:=SizeOf(IDTList)-1;
    Base:=PtrUInt(@IDTList);
  end;
  FillByte(@IDTList,0,SizeOf(IDTList));

  LoadIDT;
end;

end.
